function class(base, init)
   local c = {}    -- a new class instance
   if not init and type(base) == 'function' then
      init = base
      base = nil
   elseif type(base) == 'table' then
      for i,v in pairs(base) do
         c[i] = v
      end
      c._base = base
   end
   c.__index = c
   local mt = {}
   mt.__call = function(class_tbl, ...)
   local obj = {}
   setmetatable(obj,c)
   if init then
      init(obj,...)
   else 
      if base and base.init then
      base.init(obj, ...)
      end
   end
   return obj
   end
   c.init = init
   c.is_a = function(self, klass)
      local m = getmetatable(self)
      while m do 
         if m == klass then return true end
         m = m._base
      end
      return false
   end
   setmetatable(c, mt)
   return c
end

obj_lottery_scpt = class()
function obj_lottery_scpt:init()
    print("obj_lottery_scpt:init()")
    self.nm_lottery="lottery"..28975 --..tostring(28975)
    self.Ar_real_res={}
    self.Ar_mix_res={}
    self.Ar_mix={}
    self.Ar_real={}
end
function obj_lottery_scpt:generate()
  print("obj_lottery_scpt:generate()")
    local Ar_items=sadok_libs:data_Ar("lottery")
    local rnd_Ar_items    -- рандомное число в границах Ar_items
    local have_in_Ar     -- nil если не нашли в find_El_Ar_range или
    local buffer         -- id предмета
    local buffer_index        -- для сверки индекса
    local bool_check=true     -- флаг - есть елемент в массиве или нет
    if #Ar_items<7 then
      print("ERROR: obj_lottery_scpt:generate() - #Ar_items<7")
      do return end
    end
    for i=1,7 do
      while bool_check==true do
          buffer=sadok_libs:random_El_Ar(Ar_items)
          buffer_index=sadok_libs:find_El_Ar_range(self.Ar_real,1,i,buffer)
          if buffer_index==nil or buffer_index==i then
            bool_check=false
          end
      end
      bool_check=true
      self.Ar_real[i]=buffer
    end
    self.Ar_mix = sadok_libs:swap_Ar(self.Ar_real)  -- массив перемешанных предметов, только для стартового отображения, перед игрой
    for i=1,#self.Ar_mix do
      self.Ar_real_res[i]=viewer.getResFromTxtDB(self.Ar_real[i],1,666)
      self.Ar_mix_res[i]=viewer.getResFromTxtDB(self.Ar_mix[i],1,666)
    end
    obj_lottery_scpt:save()
end
function obj_lottery_scpt:save() -- сохраняем в опции сгенерированные карты
  print("obj_lottery_scpt:save()")
  for i=1,7 do
    viewer.setOptParamI(self.nm_lottery..".Ar_real.card_"..i,self.Ar_real[i],1)
    viewer.setOptParamI(self.nm_lottery..".Ar_real.card_"..i.."res", self.Ar_real_res[i],1)  
    viewer.setOptParamI(self.nm_lottery..".Ar_mix.card_"..i,self.Ar_mix[i],1)
    viewer.setOptParamI(self.nm_lottery..".Ar_mix.card_"..i.."res",self.Ar_mix_res[i],1)  
  end
end
function obj_lottery_scpt:state(state,guestID)
  if 	state == "generate" then
      obj_lottery_scpt:generate()
      do return end
  elseif state == "show_real" then 
    obj_lottery_scpt:load_data()
    self.show_num=1
    obj_lottery_scpt:show_cards()
  elseif state == "show_mix" then 
    obj_lottery_scpt:load_data()
    self.show_num=2
    obj_lottery_scpt:show_cards()  
  else
    print("obj_lottery_scpt:state(state,guestID) ")
  end
end
function obj_lottery_scpt:show_cards() 
  local Ar_cards={{nm="1",icon=28927},
    {nm="2",icon=28929},
    {nm="3",icon=28938},
    {nm="4",icon=28944},
    {nm="5",icon=28941},
    {nm="6",icon=28932},
    {nm="7",icon=28935}} -- массив с id иконок карт
  for i=1,#Ar_cards do
    if self.show_num==1 then
      viewer.setObjParamI(Ar_cards[i]["icon"],"res",self.Ar_real_res[i])
    else
      viewer.setObjParamI(Ar_cards[i]["icon"],"res",self.Ar_mix_res[i])
    end
    viewer.changeObjState(Ar_cards[i]["icon"],"init")
  end
end
function obj_lottery_scpt:load_data()
   for i=1,7 do
      self.Ar_real[i]=viewer.getOptParamI(self.nm_lottery..".Ar_real.card_"..i,0,1)
      self.Ar_real_res[i]=viewer.getOptParamI(self.nm_lottery..".Ar_real.card_"..i.."res",0,1)
      self.Ar_mix[i]=viewer.getOptParamI(self.nm_lottery..".Ar_mix.card_"..i,0,1)
      self.Ar_mix_res[i]=viewer.getOptParamI(self.nm_lottery..".Ar_mix.card_"..i.."res",0,1)
    end
end

obj_sales_scpt = class()
function obj_sales_scpt:init()
  print("obj_sales_scpt:init()")
  self.nm_str="sales"..tostring(28977)
  self.num_cells_const=3      -- количество ячеек активных акций
  self.Ar_but={{},{},{}}    
  self.status={}    -- статусы для каждой акции
  self.status_cnt={}  -- количество генераций акции
  self.Ar_day_buy={}  -- параметры акции дня
  self.AllActCnt=11     -- количество акций в целом
  self.def_obj=27330 -- дефолтный объект который будем дёргать
  self.Ar_Del={0,0,0,0}   -- массив с очередями на удаление
  self.Ar_Add={0,0,0,0}   -- массив с очередями на активациею
  self.sale_obj={{nm="1",obj_sale=17911,txtID=8580},
    {nm="2",obj_sale=20228,txtID=8584},
    {nm="3",obj_sale=20232,txtID=8878},
    {nm="4",obj_sale=17912,txtID=8861},
    {nm="5",obj_sale=17878,txtID=8578},
    {nm="6",obj_sale=20277,txtID=8880},
    {nm="7",obj_sale=20357,txtID=8936},
    {nm="8",obj_sale=28259,txtID=11241},
    {nm="9",obj_sale=28260,txtID=11240},
    {nm="10",obj_sale=20536,txtID=8883},
    {nm="11",obj_sale=28261,txtID=11239}}
  self.Ar_but_obj={{nm="1",btn_obj=17883,txt_obj=17887},
    {nm="2",btn_obj=17864,txt_obj=17886},
    {nm="3",btn_obj=17869,txt_obj=17882},
    {nm="3",btn_obj=20089,txt_obj=20090}} 
  if viewer.getOptParamI(self.nm_str..".read_old",0,1)~=4 then -- единоразово вычитываем параметры из старых акций
    obj_sales_scpt:ReadOld()
  end 
  obj_sales_scpt:Load()
end
function obj_sales_scpt:Add(num)  -- добавление акции в список, поиск свободной кнопки и запись статуса
  print("obj_sales_scpt:Add("..num..")")
  for i=1,self.num_cells_const do  -- проход по but_  - c проверкой на активность добавляемой акции
    if self.Ar_but[i]["txtID"]==self.sale_obj[num]["txtID"] and self.Ar_but[i]["action"]==1 then
      print("obj_sales_scpt:add() - sales was activate: index="..i)
      return false
    end
  end
  for i=1,self.num_cells_const do    -- проход по but_  поиск свободного места
    if self.Ar_but[i]["action"]==0 then
      self.Ar_but[i]["obj_sale"]=self.sale_obj[num]["obj_sale"]
      self.Ar_but[i]["txtID"]=self.sale_obj[num]["txtID"]
      self.Ar_but[i]["action"]=1
      self.Ar_but[i]["num"]=num
      self.status[num]=1
      self.num_action=self.num_action+1  -- num_action++
      self.status_cnt[num]=self.status_cnt[num]+1
      self.NumAdd=self.NumAdd+1
      self.Ar_Add[self.NumAdd]=num
      obj_sales_scpt:Save()  -- сохраняемся
      return true
    end
  end
  return false
end
function obj_sales_scpt:Del(num) -- удаление из but_  и изменение статуса
  obj_sales_scpt:Load()
  print("obj_sales_scpt:Del("..num..")")
  local del_obj=self.def_obj
  for i=1,self.num_cells_const do    -- проход по кнопкам
    print("self.Ar_but["..i.."][txtID]="..self.Ar_but[i]["txtID"])
    if self.Ar_but[i]["txtID"]==self.sale_obj[num]["txtID"] then
       print("delete_from_but_"..i)
      del_obj=self.Ar_but[i]["obj_sale"]
      self.Ar_but[i]["obj_sale"]=0
      self.Ar_but[i]["txtID"]=0
      self.Ar_but[i]["action"]=0
      self.Ar_but[i]["num"]=0
      self.num_action=self.num_action-1
    end
  end
  if num~=10 and num~=7 then  -- акции 10 и 7-м не имеют последнего шанса
    if self.status[num]~=10 then
      self.NumDel=self.NumDel+1
      self.Ar_Del[self.NumDel]=num
      self.status[num]=2
    end
  else
  end
  viewer.changeObjState(del_obj,"off")
  obj_sales_scpt:Save()
  viewer.changeObjState(28981,"check")
end
function obj_sales_scpt:Load()  -- загрузка значений из опций в скрипт в self
  print("obj_sales_scpt:Load()")
  self.num_action=0   
  for i=1,self.num_cells_const do    -- считываем всё кроме статуса
    if viewer.getOptParamI(self.nm_str..".but_"..i..".action",0,1)==1 then
      self.Ar_but[i]["obj_sale"]=viewer.getOptParamI(self.nm_str..".but_"..i..".obj_sale",self.def_obj,1)
      self.Ar_but[i]["txtID"]=viewer.getOptParamI(self.nm_str..".but_"..i..".txtID",-1,1)
      self.Ar_but[i]["num"]=viewer.getOptParamI(self.nm_str..".but_"..i..".num",-1,1)
      self.Ar_but[i]["action"]=1
      self.num_action=self.num_action+1   -- num_action++
    else
      self.Ar_but[i]["obj_sale"]=self.def_obj
      self.Ar_but[i]["txtID"]=0
      self.Ar_but[i]["action"]=0
    end
  end
  for i=1,self.AllActCnt do  -- считываем статусы всех акций
    self.status[i]=viewer.getOptParamI(self.nm_str..".status.act_"..i,0,1)
    if self.status[i]==4 then
      self.status[i]=1    -- убираем рудимент
    end
    self.status_cnt[i]=viewer.getOptParamI(self.nm_str..".status_cnt.act_"..i,0,1)
  end
  do -- вычитываем акцию дня
    local Ar_names = obj_sales_scpt:GetAr("day_sale_names")
    for i=1,#Ar_names do
      self.Ar_day_buy[Ar_names[i]]=viewer.getOptParamI(self.nm_str..".day_buy."..Ar_names[i],0,1)
    end
  end
  do -- считываем last_obj
    self.last_num_del=viewer.getOptParamI(self.nm_str..".last_num_del",0,1)
    self.last_num_add=viewer.getOptParamI(self.nm_str..".last_num_add",0,1)
    self.last_btn_tap=viewer.getOptParamI(self.nm_str..".last_btn_tap",0,1)
    self.last_open=viewer.getOptParamI(self.nm_str..".last_open",self.def_obj,1)
  end
  do -- очередь удаления последних шансов
    self.NumDel=viewer.getOptParamI(self.nm_str..".Ar_Del_Add.num_del",0,1)
    self.NumAdd=viewer.getOptParamI(self.nm_str..".Ar_Del_Add.num_add",0,1)
    for i=1,self.num_cells_const do
      self.Ar_Del[i]=viewer.getOptParamI(self.nm_str..".Ar_Del_Add.del_"..i,0,1)
      self.Ar_Add[i]=viewer.getOptParamI(self.nm_str..".Ar_Del_Add.add_"..i,0,1)
    end
  end
end
function obj_sales_scpt:LoadBtn(ignore_num)
  print("obj_sales_scpt:LoadBtn()")
  self.ignore_num=ignore_num
  for i=1,self.num_cells_const do
    viewer.changeObjState(self.Ar_but[i]["obj_sale"] or self.def_obj,"off")
    if self.Ar_but[i]["action"]==1 then
      if self.ignore_num~=i then
        viewer.changeObjState(self.Ar_but_obj[i]["btn_obj"] or self.def_obj,"up")
      end
    else
      viewer.changeObjState(self.Ar_but_obj[i]["btn_obj"] or self.def_obj,"disable")
    end
    viewer.setObjParamI(self.Ar_but_obj[i]["txt_obj"],"txtID",self.Ar_but[i]["txtID"]) -- инитим текст
    viewer.changeObjState(self.Ar_but_obj[i]["txt_obj"],"init")
  end
  if self.num_action==1 then -- двигаем кнопочки если одна
    for i=1,self.num_cells_const do
      if self.Ar_but[i]["action"]==1 then
          viewer.setObjParamI(self.Ar_but_obj[i]["btn_obj"],"x",0)
      end
    end  
  elseif self.num_action==2 then -- двигаем кнопочки если их две
    local cnt_btn=2
    for i=1,self.num_cells_const do
      if self.Ar_but[i]["action"]==1 then
        if cnt_btn==2 then
          viewer.setObjParamI(self.Ar_but_obj[i]["btn_obj"],"x",-140)
          cnt_btn=cnt_btn-1
        elseif cnt_btn==1 then
          viewer.setObjParamI(self.Ar_but_obj[i]["btn_obj"],"x",140)
          cnt_btn=cnt_btn-1
        end  
      end
    end
  elseif self.num_action==3 then -- двигаем кнопочки если их три
    viewer.setObjParamI(self.Ar_but_obj[1]["btn_obj"],"x",-280)
    viewer.setObjParamI(self.Ar_but_obj[2]["btn_obj"],"x",0)
    viewer.setObjParamI(self.Ar_but_obj[3]["btn_obj"],"x",280)  
  end  
end
function obj_sales_scpt:Save()  -- сохранения акций в опции по тегу salesID
  print("obj_sales_scpt:Save()")
  viewer.setOptParamI(self.nm_str..".num_cells",self.num_cells_const,1)
  viewer.setOptParamI(self.nm_str..".num_action",self.num_action,1)
  for i=1,self.num_cells_const do   -- сохраняем ячейки, активные акции
    viewer.setOptParamI(self.nm_str..".but_"..i..".obj_sale",self.Ar_but[i]["obj_sale"],1) 
    viewer.setOptParamI(self.nm_str..".but_"..i..".txtID",self.Ar_but[i]["txtID"],1)
    viewer.setOptParamI(self.nm_str..".but_"..i..".num",self.Ar_but[i]["num"],1)
    viewer.setOptParamI(self.nm_str..".but_"..i..".action",self.Ar_but[i]["action"],1)
  end
  for i=1,self.AllActCnt do  -- сохраняем статусы всех акций
    viewer.setOptParamI(self.nm_str..".status.act_"..i,self.status[i],1) 
    viewer.setOptParamI(self.nm_str..".status_cnt.act_"..i,self.status_cnt[i],1) 
  end
  do -- сохраняем акцию дня
    local Ar_names = obj_sales_scpt:GetAr("day_sale_names")
    for i=1,#Ar_names do
      viewer.setOptParamI(self.nm_str..".day_buy."..Ar_names[i],self.Ar_day_buy[Ar_names[i]],1)
    end
  end
  do -- сохраняем last_obj
    viewer.setOptParamI(self.nm_str..".last_num_del",self.last_num_del or 0,1)
    viewer.setOptParamI(self.nm_str..".last_num_add",self.last_num_add or 0,1)
  end
  if self.num_action>0 then --пинаем язычок акций
    if viewer.getObjParamI(21119,"al",0)==0 then
      viewer.changeObjState(21119,"init")
    end
  else
    if viewer.getObjParamI(21119,"al",0)==1 then
      viewer.changeObjState(21119,"init")
    end
  end
  do -- очередь удаления последних шансов, показа новых акций
    viewer.setOptParamI(self.nm_str..".Ar_Del_Add.num_del",self.NumDel,1)
    viewer.setOptParamI(self.nm_str..".Ar_Del_Add.num_add",self.NumAdd,1)
    for i=1,self.num_cells_const do
      viewer.setOptParamI(self.nm_str..".Ar_Del_Add.del_"..i,self.Ar_Del[i],1)
      viewer.setOptParamI(self.nm_str..".Ar_Del_Add.add_"..i,self.Ar_Add[i],1)
    end
  end
  obj_sales_scpt:SaveLastBtn()
end 
function obj_sales_scpt:SaveLastBtn()
  print("obj_sales_scpt:SaveLastBtn()")
  viewer.setOptParamI(self.nm_str..".last_btn_tap",self.last_btn_tap or 0,1)
  viewer.setOptParamI(self.nm_str..".last_open",self.last_open or self.def_obj,1)
end
function obj_sales_scpt:ReadOld() -- если есть старые акции, перенос значений в скрипт
  print("obj_sales_scpt:ReadOld()")
  self.num_action=0
  local OldVal=viewer.getOptParamI("sales.europe.status.act_05",0,0)
  local ValBeforeSM=viewer.getOptParamI(self.nm_str..".status.act_5",0,1)
  if OldVal>ValBeforeSM then
    obj_sales_scpt:ReadOldStatus(5,OldVal)
  else
    obj_sales_scpt:ReadOldStatus(5,ValBeforeSM)
  end
  viewer.setObjParamS(46,"param","sales28977") -- чистим ноду
  viewer.changeObjState(46,"delete_node" )
  viewer.setOptParamI(self.nm_str..".read_old",4,1)  -- чтобы больше не выполнять
  obj_sales_scpt:Save()
end 
function obj_sales_scpt:ReadOldStatus(number,val) -- перенос старого статуса в новый
  print("obj_sales_scpt:ReadOldStatus()")
  if number==5 or number==1 then -- доп. условия т.к. одноразовые
    if val==10 then
      self.status[number]=10
    elseif val==2 then
      self.status[number]=2
    else
      self.status[number]=0
    end
  else                    -- для всех остальных акций всё просто
    self.status[number]=0
  end
end
function obj_sales_scpt:GetAr(Ar_lists_sales) --  возвращает массив данных по ключевому слову
  print("obj_sales_scpt:GetAr()")
  local Ar_day_sale_names={"wait","price_type","price_sale","price","item_id","res_id","sale_check_box_achieve"}
 if Ar_lists_sales=="day_sale_names" then
    return Ar_day_sale_names
  end
  return nil
end
function obj_sales_scpt:LastChance() -- открываем последний шанс
  print("obj_sales_scpt:LastChance()")
  self.last_num_del=self.Ar_Del[self.NumDel]
  viewer.changeObjState(self.last_open,"off")
  if self.Ar_Del[self.NumDel]<1 or self.Ar_Del[self.NumDel]>self.AllActCnt then  -- проверка на out_of_range
    print("obj_sales_scpt:LastChance() - break, out_of_range: self.Ar_Del["..self.NumDel.."]="..self.Ar_Del[self.NumDel].."    self.AllActCnt="..self.AllActCnt)
    return
  end
  self.last_open=self.sale_obj[self.last_num_del]["obj_sale"]
  self.NumDel=self.NumDel-1
  obj_sales_scpt:Save()
  viewer.setObjParamI(17885,"txtID",self.sale_obj[self.last_num_del]["txtID"])
  viewer.changeObjState(17885,"init")
  viewer.changeObjState(self.last_open,"show")
end
function obj_sales_scpt:OpenNew() -- открываем новую акцию
  print("obj_sales_scpt:OpenNew()")
  self.last_num_add=self.Ar_Add[self.NumAdd]
  viewer.changeObjState(self.last_open,"off")
  if self.Ar_Add[self.NumAdd]<1 or self.Ar_Add[self.NumAdd]>self.AllActCnt then -- проверка на out_of_range
    print("obj_sales_scpt:OpenNew() - break, out_of_range: self.Ar_Add["..self.NumAdd.."]="..self.Ar_Add[self.NumAdd].."    self.AllActCnt="..self.AllActCnt)
    return
  end
  viewer.setObjParamI(17885,"txtID",self.sale_obj[self.last_num_add]["txtID"])
  self.last_open=self.sale_obj[self.last_num_add]["obj_sale"]
  self.last_num_add=self.Ar_Add[self.NumAdd]
  self.NumAdd=self.NumAdd-1
  viewer.changeObjState(17885,"init")
  obj_sales_scpt:Save()
  viewer.changeObjState(self.last_open,"show")
end
function obj_sales_scpt:DaySaleGen() -- генерируем предмет
  print("obj_sales_scpt:DaySaleGen()")
  local Ar_items=sadok_libs:data_Ar("day_sale")
  local item_gen=sadok_libs:random_El_Ar(Ar_items)
  self.Ar_day_buy["item_id"]=item_gen
  print("obj_sales_scpt:day_sale_gen() -> item_id="..item_gen)
  self.Ar_day_buy["res_id"]=viewer.getResFromTxtDB(item_gen,1,1702)
  self.Ar_day_buy["wait"]=1
  viewer.setObjParamI(eitems_id,"param",self.Ar_day_buy["item_id"])
  viewer.changeObjState(eitems_id,"check_price")
  local val_res1 = viewer.getObjParamI(eitems_id,"checked_res1",0)
  local val_res2 = viewer.getObjParamI(eitems_id,"checked_res2",0)
  if val_res1>0 then
    self.Ar_day_buy["price_type"]=1
    self.Ar_day_buy["price"]=val_res1
  elseif val_res2>0 then
    self.Ar_day_buy["price_type"]=2
    self.Ar_day_buy["price"]=val_res2
  end  
  self.Ar_day_buy["price_sale"]=math.ceil(self.Ar_day_buy["price"]*0.7)
  obj_sales_scpt:Save()
end
function obj_sales_scpt:TimerSet(num,timer_id) -- запуск таймера в окне акций
   print("obj_sales_scpt:TimerSet()")
  if (num==0) then -- проверка на последний шанс
    viewer.changeObjState(28264, "last_chance")
  else
    local IdScenario = viewer.getOptParamS(self.nm_str..".scenario.act_"..num,"none",1)
    if (IdScenario == "none") then
      print("Object which called set_timer_of_sales didn't have parametr sales_scenario")
    else
      local IdTimer_1 = timer_id
      if (timer_id==-1) then
        IdTimer_1 = 17904 -- ID таймера по умолчанию
      end
      local pathToTime = "salesmanager"..tostring(29118)..".ev"..IdScenario..".tl"
      viewer.changeObjState(29144, "pause")
      viewer.changeObjState(29144, "save") -- ID таймера на главном экране
      local actualTime = viewer.getOptParamI(pathToTime, 0, 1) * 1000
      actualTime=actualTime-viewer.getOptParamI(self.nm_str..".timer.time",0,1)
      if (actualTime<0) then
        actualTime=0
      end  
      viewer.changeObjState(29144, "run")
      viewer.setObjParamS(IdTimer_1, "val", actualTime)
      viewer.changeObjState(IdTimer_1, "init")
      viewer.changeObjState(IdTimer_1, "run")
    end 
  end
end  
function obj_sales_scpt:TimerSet_active() -- запуск на мейне таймеров для активных акций
  local Ar_Timer={29151,
                  29152,
                  29153}  -- массив с id таймеров
  print("obj_sales_scpt:TimerSet_active()")
  for i=1,self.num_cells_const do    -- проход по кнопкам
    if self.Ar_but[i]["action"]==1 then
      obj_sales_scpt:TimerSet(self.Ar_but[i]["num"],Ar_Timer[i])
    end
  end
end  
function obj_sales_scpt:state(state,guestID)
  print("obj_sales_scpt:state(state="..state..",".."guestID="..guestID..")")
  function ButShow(num_but)
    self.num_but_save=num_but
    obj_sales_scpt:LoadBtn(self.num_but_save)
    if self.Ar_but[num_but]["action"]==1 then
      ViewBtn(self.num_but_save,2)
    else
      print("ERROR: but_show("..self.num_but_save..") - action==0 ")
    end
  end
  function MixBtn()  -- показываем следующую акцию
    obj_sales_scpt:LoadBtn()
    print("obj_sales_scpt:MixBtn()")
    if self.last_btn_tap==self.num_cells_const then
      print("obj_sales_scpt:mix_btn() --- self.last_btn_tap==self.num_cells_const")
      for i=1,self.num_cells_const do
        if self.Ar_but[i]["action"]==1 then
           ViewBtn(i,1)
          return
        end
      end 
    else
      print("obj_sales_scpt:mix_btn() --- self.last_btn_tap~=self.num_cells_const")
      print("obj_sales_scpt:mix_btn() --- for(i=self.last_btn_tap+1)")
      for i=self.last_btn_tap+1,self.num_cells_const do
        if self.Ar_but[i]["action"]==1 then
          print("obj_sales_scpt:mix_btn() ---  "..self.Ar_but_obj[i]["btn_obj"])
          ViewBtn(i,1)
          return
        end
      end 
      print("obj_sales_scpt:mix_btn() --- for(i=1)")
      for i=1,self.last_btn_tap do
        if self.Ar_but[i]["action"]==1 then
          ViewBtn(i,1)
          return
        end
      end 
    end
  end
  function ViewBtn(index,Bool) -- когда нашли следующую кнопку
    print("obj_sales_scpt:ViewBtn("..index..","..Bool..")") 
    self.last_btn_tap=index
    self.Bool=Bool
    viewer.changeObjState(self.last_open,"off")
    viewer.setObjParamI(17885,"txtID",self.Ar_but[self.last_btn_tap]["txtID"])
    viewer.changeObjState(17885,"init")
    self.last_open=self.Ar_but[self.last_btn_tap]["obj_sale"]
    obj_sales_scpt:SaveLastBtn()
    if self.Bool==1 then -- если попал сюда из кнопки не дёргаем гостя
      viewer.changeObjState(self.Ar_but_obj[self.last_btn_tap]["btn_obj"],"tap_draw")
    end 
    viewer.changeObjState(self.Ar_but[self.last_btn_tap]["obj_sale"],"show")
  end  
	
  if (state == "delete") then
    obj_sales_scpt:Del(viewer.getObjParamI(28977,"delete_num",0))
  elseif (state == "but_show") then
    ButShow(viewer.getObjParamI(28977,"show_btn_num",0)) 
  elseif (state == "mix_btn") then
    MixBtn()
  elseif (state == "LastChance") then
    obj_sales_scpt:LastChance()
  elseif (state == "OpenNew") then
    obj_sales_scpt:OpenNew()
  elseif (state == "DaySaleGen") then
    obj_sales_scpt:DaySaleGen()
  elseif (state == "add") then
    obj_sales_scpt:Add(viewer.getObjParamI(28977,"add_num",0)) 
  elseif (state == "timer_set") then
    obj_sales_scpt:TimerSet(viewer.getObjParamI(28977,"timer_num",0),-1)
  elseif (state == "TimerSet_active") then
    obj_sales_scpt:TimerSet_active()
  else 
     print("ERROR: no state obj_sales_scpt:state(state="..state..",".."guestID="..guestID..")")
	end
end

obj_set_opt_scpt = class() -- для правки опции в зависимости от стартового континента + фикс 
function obj_set_opt_scpt:init()
  print("obj_set_opt_scpt:init()")
  sadok_libs:economics_read()
  print("obj_set_opt_scpt:init()_continue")
  if self.once_session_set==nil then
    obj_set_opt_scpt:once_session()
    obj_set_opt_scpt:set_un_loc_eu()
  end
end 
function obj_set_opt_scpt:start()
  print("obj_set_opt_scpt:start()")
  sadok_libs:economics_read()
  print("obj_set_opt_scpt:start()_continue")
  viewer.setOptParamI("set_data.uniform_reset_eu",1,0) 
  viewer.setOptParamI("set_data.uniform_reset_as",1,0) 
  if viewer.getOptParamI("set_data.first_set",0,0)<10 then -- одноразовый сет, для генерации тасков
    obj_set_opt_scpt:once()
  end
end
function obj_set_opt_scpt:once_session() -- разово при старте сессии
  print("obj_set_opt_scpt:once()")
  for i=1,7 do
    viewer.setOptParamI("flurry.europe.trivia.cnt_session.cat"..i-1,0,0) -- инитим каунтер cat0 - cat6
  end
  obj_set_opt_scpt:fix_tasks()
  self.once_session_set=1
end
function obj_set_opt_scpt:once() -- разово, делаем при первом старте
  print("obj_set_opt_scpt:once()")
  if viewer.getOptParamI("set_data.first_set",0,0)==0 then -- при первом сете 
    viewer.setOptParamI("ecomics21.loc0.un",1,1)
    viewer.setOptParamI("ecomics21.loc1.un",1,1)
    viewer.setOptParamI("minigames.europe.casino.simNum_cnt",5,1)
    viewer.setOptParamI("generate.europe.quiz",1,1)
    viewer.setOptParamI("items.hint.trivia_01",1,1)
    viewer.setOptParamI("items.hint.trivia_02",1,1)
    viewer.setOptParamI("items.hint.trivia_03",1,1)
    viewer.setOptParamI("items.hint.trivia_04",1,1)
  end
  viewer.setOptParamI("trivia17685.cur_add_coef",1,1)            -- для новых и старых опций
  viewer.setOptParamS("set_data.first_set",viewer.getOptParamS("VersionString",0,0),0)
  viewer.changeObjState(3536,"clear") 
end
function obj_set_opt_scpt:fix_tasks()  -- починка багов с тасками
  print("obj_set_opt_scpt:fix_tasks()")
  if viewer.getOptParamI("tasks23435.t5134.s",0,1)>2 then
    viewer.setOptParamI("generate.europe.poll_activate",1,1)
    viewer.setOptParamI("generate.t_deposit_1",1,1)
  end
  if viewer.getOptParamI("set_data.fix.active_tasks_europe",0,0)==0 then -- для webok, новые условия
    if viewer.getOptParamI("tasks23435.t6660.s",0,1)>2 then  
      viewer.setOptParamI("active.quiz_tasks_europe",1,1)
    end
    if viewer.getOptParamI("tasks23435.t5129.s",0,1)>2 then
      viewer.setOptParamI("active.line_tasks_europe",1,1)
    end
    if viewer.getOptParamI("tasks23435.t10502.s",0,1)>2 then
      viewer.setOptParamI("active.minigame_tasks_europe",1,1)
    end
    viewer.setOptParamI("set_data.fix.active_tasks_europe",viewer.getOptParamS("VersionString",0,0),0)
  end
  if viewer.getOptParamI("set_data.fix.puzzle_lvl_asia",0,1)==0 then  -- зануление уровней Азии, чтобы наши акки подпереть
    viewer.setOptParamS("param","minigames.asia.puzzle",0)
    viewer.changeObjState(46,"delete_node") 
    viewer.setOptParamI("set_data.fix.puzzle_lvl_asia",viewer.getOptParamS("VersionString",0,0),0)
  end
  if viewer.getOptParamI("set_data.fix.task_anom_eu",0,0)<2 then  -- фикс тасков на аномалии Европа
    local data_anomaly={{5872,5873,5874,5875},
                        {5876,5877,5878,5879},
                        {8854,5881,5882,5883},
                        {5884,5885,5886,5887},
                        {5888,5889,5890,5891},
                        {5892,5893,5894,5895},
                        {5896,5897,5898,5899},
                        {5900,5901,5902,5903},
                        {5904,5905,5906,5907},
                        {5908,5909,5910,5911},
                        {5912,5913,5914,5915},
                        {5916,5917,5918,5919}}
    if viewer.getOptParamI("tasks23435.t5880.s",0,1)<3 then 
      viewer.setOptParamI("tasks23435.t5880.s",0,1)
    end  
    for i=1,12 do
      for a=1,4 do
        local s_tasks=viewer.getOptParamI("tasks23435.t"..data_anomaly[i][a]..".s",0,1)
        if s_tasks==1 or s_tasks==2 then
          viewer.setOptParamI("tasks23435.t"..data_anomaly[i][a]..".s",0,1)
        end 
      end
    end
    viewer.setOptParamI("set_data.fix.task_anom_eu",2,0)
  end
  if viewer.getOptParamI("set_data.fix.task_anom_as",0,0)<1 then -- фикс тасков на аномалии Азия
    local data_anomaly={{11154,11155,11156,11153},
                        {11149,11150,11151,11152},
                        {11145,11146,11147,11148},
                        {11141,11142,11143,11144},
                        {11137,11138,11139,11140},
                        {11133,11134,11135,11136},
                        {11129,11130,11131,11132},
                        {11125,11126,11127,11128},
                        {11121,11122,11123,11124},
                        {11117,11118,11119,11120},
                        {11113,11114,11115,11116},
                        {11109,11110,11111,11112}}
    for i=1,12 do
      for a=1,4 do
        local s_tasks=viewer.getOptParamI("tasks145.t"..data_anomaly[i][a]..".s",0,1)
        if s_tasks==1 or s_tasks==2 then
          viewer.setOptParamI("tasks145.t"..data_anomaly[i][a]..".s",0,1)
        end 
      end
    end
    viewer.setOptParamI("set_data.fix.task_anom_as",1,0)
  end
end  
function obj_set_opt_scpt:state(state,guestID)
  print("obj_set_opt_scpt:state(state="..state..",".."guestID="..guestID..")")
  	
  if (state == "start") then
    obj_set_opt_scpt:start()
  elseif (state == "check_lvl_unlock") then
    obj_set_opt_scpt:check_lvl_unlock()
  else
    print("ERROR: no state  obj_set_opt_scpt:state(state="..state..",".."guestID="..guestID..")")
	end
end
function obj_set_opt_scpt:set_un_loc_eu()  -- цены в опции  Европа
    self.Loc_data={
    {n="0",  Eu_pr=1,     Eu_tp=0, As_pr=20000, As_tp=1},
    {n="1",  Eu_pr=1,     Eu_tp=0, As_pr=24000, As_tp=1},
    {n="2",  Eu_pr=2,     Eu_tp=0, As_pr=14,    As_tp=0},
    {n="3",  Eu_pr=10000, Eu_tp=1, As_pr=28000, As_tp=1},
    {n="4",  Eu_pr=12000, Eu_tp=1, As_pr=22,    As_tp=0},
    {n="5",  Eu_pr=6,     Eu_tp=0, As_pr=30000, As_tp=1},
    {n="6",  Eu_pr=14000, Eu_tp=1, As_pr=16,    As_tp=0},
    {n="7",  Eu_pr=8,     Eu_tp=0, As_pr=4,     As_tp=0},
    {n="8",  Eu_pr=16000, Eu_tp=1, As_pr=18,    As_tp=0},
    {n="9",  Eu_pr=10,    Eu_tp=0, As_pr=22000, As_tp=1},
    {n="10", Eu_pr=18000, Eu_tp=1, As_pr=27,    As_tp=0 },
    {n="11", Eu_pr=12,    Eu_tp=0, As_pr=26000, As_tp=1}}  -- цена и тип анлока ( _tp - type 0 - xp, 1 - res1)
    obj_set_opt_scpt:save_unlock_price()
  end	
function obj_set_opt_scpt:save_unlock_price() -- сохраняем экономические цены
  local str_Eu="ecomics"..economics_eu..".loc"
  local str_As="ecomics"..economics_as..".loc"
  print("obj_set_opt_scpt:save_unlock_price()")
  for i=1,12 do
    viewer.setOptParamI(str_Eu..(i-1)..".un_val",self.Loc_data[i]["Eu_pr"],1)
    viewer.setOptParamI(str_Eu..(i-1)..".un_type",self.Loc_data[i]["Eu_tp"],1)
    viewer.setOptParamI(str_As..(i-1)..".un_val",self.Loc_data[i]["As_pr"],1)
    viewer.setOptParamI(str_As..(i-1)..".un_type",self.Loc_data[i]["As_tp"],1)
  end
  viewer.setOptParamI("set_data.once_set",viewer.getOptParamS("VersionString",0,0),0) 
end
function obj_set_opt_scpt:check_lvl_unlock() -- проверка на анлок локации
  print("obj_set_opt_scpt:check_lvl_unlock()")
  sadok_libs:economics_read()
  print("obj_set_opt_scpt:check_lvl_unlock()_continue")
  local str_econ="Eu" -- индификатор текущей экономики
  local str_par="Eu" -- индификатор текущей экономики
  local id_str={}     -- массив с id
  if user_land_play=="europe" then
    str_par="Eu"
    str_econ="ecomics"..economics_eu..".loc"
    id_str={21050,
      21033,
      21054,
      21037,
      21060,
      21043,
      21067,
      21086,
      21073,
      21092,
      21079,
      21098}
  elseif user_land_play=="asia" then   
    str_par="As"
    str_econ="ecomics"..economics_as..".loc"
    id_str={19450,
      19433,
      19454,
      19437,
      19460,
      19443,
      19467,
      19486,
      19473,
      19492,
      19479,
      19498}
  else
    print("obj_set_opt_scpt:check_lvl_unlock()  - ERROR , NO user_land_play -"..user_land_play)
  end
  print("obj_set_opt_scpt:check_lvl_unlock(): str_par="..str_par.."  str_econ="..str_econ)
  for i=1,12 do
    print("self.Loc_data["..13-i.."]["..str_par.."_tp]="..self.Loc_data[13-i][str_par.."_tp"])
    print("self.Loc_data["..13-i.."]["..str_par.."_pr]="..self.Loc_data[13-i][str_par.."_pr"])
    print("EconomicsLevel="..EconomicsLevel)
    if self.Loc_data[13-i][str_par.."_tp"]==0 and self.Loc_data[13-i][str_par.."_pr"]<=EconomicsLevel then
      if viewer.getOptParamI(str_econ..12-i..".un",55,1)==0 then
        viewer.changeObjState(id_str[13-i],"unlock_wait")
        break
      end
    end
  end
end

obj_wnd_bg_scpt = class()
bg_data={bg_id=21332,
      anim_pos_id=21333,
      decor_id=21334,
      body_id=29016} -- данные окошка оригинала
bg_datash={bg_id=29019, 
      decor_id=21350,
      body_id=29016} -- данные окошка тени ( находится в предыдущем месте окошка оригинала)
function obj_wnd_bg_scpt:init()
  self.pragma_once=0
  if self.pragma_once==0 then -- делаем только первый раз
    self.id_parent_change=29015  -- const машина кот. меняет фон в родителя
    self.pragma_once=1
  end
  print(bg_data["body_id"])
  print(bg_datash["body_id"])
  obj_wnd_bg_scpt:InitManual()
end
function obj_wnd_bg_scpt:InitManual()
  print("obj_wnd_bg_scpt:InitManual()")
  self.num_cell=1
  self.cell={{},{},{},{},{},{},{},{}}
  self.cell[self.num_cell]["st"]="bg_1"
  self.cell[self.num_cell]["obj"]=29016
end
function obj_wnd_bg_scpt:ReloadRes(set_land) -- замена графики в зависимости от материка
  if set_land==1 then
    bg_data["body_id"]=21335
    bg_datash["body_id"]=21351
  elseif set_land==2 then 
    bg_data["body_id"]=20207
    bg_datash["body_id"]=20027
  else
    print("ERROR: obj_wnd_bg_scpt:reload_res() - set_land="..set_land)
  end  
end  
function obj_wnd_bg_scpt:MoveBack(guestID) -- перемещение фоно обратно
  print("obj_wnd_bg_scpt:MoveBack - guestID="..guestID)
  if self.num_cell>2 then
    self.num_cell=self.num_cell-1
  else
    print("obj_wnd_bg_scpt:MoveBack - self.num_cell<1  - ignore move_back - move default")
    self.num_cell=1
  end
  viewer.setObjParamI(29014,"guestID_main",self.cell[self.num_cell]["obj"]) 
  viewer.setObjParamI(29014,"guestID_sh",self.cell[self.num_cell+1]["obj"])
  obj_wnd_bg_scpt:MoveBg(self.cell[self.num_cell]["st"],bg_data)
  obj_wnd_bg_scpt:MoveBg(self.cell[self.num_cell+1]["st"],bg_datash)
  viewer.changeObjState(self.id_parent_change,"start")
  print("obj_wnd_bg_scpt:MoveBack() - guestID_main="..self.cell[self.num_cell]["obj"].." st="..self.cell[self.num_cell+1]["st"].."  guestID_sh="..self.cell[self.num_cell+1]["obj"].." st="..self.cell[self.num_cell+1]["st"])
end  
function obj_wnd_bg_scpt:MoveUp(state,guestID)
  print("obj_wnd_bg_scpt:MoveUp("..state..","..guestID..")")
  self.num_cell=self.num_cell+1
  self.cell[self.num_cell]["st"]=state
  self.cell[self.num_cell]["obj"]=guestID
  viewer.setObjParamI(29014,"guestID_main",guestID) 
  viewer.setObjParamI(29014,"guestID_sh",self.cell[self.num_cell-1]["obj"])
  obj_wnd_bg_scpt:MoveBg(state,bg_data)
  obj_wnd_bg_scpt:MoveBg(self.cell[self.num_cell-1]["st"],bg_datash)
  print("obj_wnd_bg_scpt:MoveUp() - guestID_main="..self.cell[self.num_cell]["obj"].." st="..self.cell[self.num_cell]["st"].."  guestID_sh="..self.cell[self.num_cell-1]["obj"].." st="..self.cell[self.num_cell-1]["st"])
  viewer.changeObjState(self.id_parent_change,"start")
end
function obj_wnd_bg_scpt:MoveBg(state,Ar_data) -- перемещение к новому родителю (открытие нового окна)
  if state=="bg_1" then
    viewer.setObjParamI(Ar_data["bg_id"],"al",1)
    viewer.setObjParamI(Ar_data["decor_id"],"al",0)
    viewer.changeObjState(Ar_data["body_id"],"bg_1")
  elseif state=="bg_2" then
    viewer.setObjParamI(Ar_data["bg_id"],"al",1)
    viewer.setObjParamI(Ar_data["decor_id"],"al",0)
    viewer.changeObjState(Ar_data["body_id"],"bg_2_middle")
  elseif state=="bg_3" then
    viewer.setObjParamI(Ar_data["bg_id"],"al",1)
    viewer.setObjParamI(Ar_data["decor_id"],"al",0)
    viewer.changeObjState(Ar_data["body_id"],"bg_3")
  elseif state=="bg_4" then
    viewer.setObjParamI(Ar_data["bg_id"],"al",1)
    viewer.setObjParamI(Ar_data["decor_id"],"al",0)
    viewer.changeObjState(Ar_data["body_id"],"bg_4_w_green")
  elseif state=="bg_4_al" then
    viewer.setObjParamI(Ar_data["bg_id"],"al",1)
    viewer.setObjParamI(Ar_data["decor_id"],"al",0)
    viewer.changeObjState(Ar_data["body_id"],"bg_4_w_green")
  elseif state=="bg_5" then
    viewer.setObjParamI(Ar_data["bg_id"],"al",1)
    viewer.setObjParamI(Ar_data["decor_id"],"al",1)
    viewer.setObjParamI(Ar_data["decor_id"],"x",-334)
    viewer.setObjParamI(Ar_data["decor_id"],"y",-24)
    viewer.changeObjState(Ar_data["body_id"],"bg_5")
  elseif state=="bg_8" then
    viewer.setObjParamI(Ar_data["bg_id"],"al",1)
    viewer.setObjParamI(Ar_data["decor_id"],"al",1)
    viewer.setObjParamI(Ar_data["decor_id"],"x",-334)
    viewer.setObjParamI(Ar_data["decor_id"],"y",-24)
    viewer.changeObjState(Ar_data["body_id"],"bg_5")
  elseif state=="bg_5_1" then
    viewer.setObjParamF(Ar_data["bg_id"],"al",0.4)
    viewer.setObjParamI(Ar_data["decor_id"],"al",1)
    viewer.setObjParamI(Ar_data["decor_id"],"x",-334)
    viewer.setObjParamI(Ar_data["decor_id"],"y",-24)
    viewer.changeObjState(Ar_data["body_id"],"bg_5")
  elseif state=="bg_5_al_0" then
    viewer.setObjParamI(Ar_data["bg_id"],"al",0)
    viewer.setObjParamI(Ar_data["decor_id"],"al",0)
    viewer.changeObjState(Ar_data["body_id"],"bg_5")
  elseif state=="bg_6" then
    viewer.setObjParamI(Ar_data["bg_id"],"al",1)
    viewer.setObjParamI(Ar_data["decor_id"],"al",1)
    viewer.setObjParamI(Ar_data["decor_id"],"x",-467)
    viewer.setObjParamI(Ar_data["decor_id"],"y",-166)
    viewer.changeObjState(Ar_data["body_id"],"bg_windows")             
  elseif state=="bg_6_al" then
    viewer.setObjParamF(Ar_data["bg_id"],"al",0.4)
    viewer.setObjParamI(Ar_data["decor_id"],"al",1)
    viewer.setObjParamI(Ar_data["decor_id"],"x",-467)
    viewer.setObjParamI(Ar_data["decor_id"],"y",-166)
    viewer.changeObjState(Ar_data["body_id"],"bg_windows")
  elseif state=="bg_6_al_0" then
    viewer.setObjParamI(Ar_data["bg_id"],"al",0)
    viewer.setObjParamI(Ar_data["decor_id"],"al",0)
    viewer.changeObjState(Ar_data["body_id"],"bg_windows")
  elseif state=="bg_7" then
    viewer.setObjParamI(Ar_data["bg_id"],"al",1)
    viewer.setObjParamI(Ar_data["decor_id"],"al",0)
    viewer.changeObjState(Ar_data["body_id"],"bg_2_new_task")
  elseif state=="bg_7_centre" then
    viewer.setObjParamI(Ar_data["bg_id"],"al",1)
    viewer.setObjParamI(Ar_data["decor_id"],"al",0)
    viewer.changeObjState(Ar_data["body_id"],"bg_2_new_task_centre")
  else
    print("ERROR:obj_wnd_bg_scpt:MoveBg()  - no state  ("..state..")")
  end 
end  
function obj_wnd_bg_scpt:state(state,guestID)
  print("obj_wnd_bg_scpt:state("..state..","..guestID..")")
	if 	state == "move_back" then
		obj_wnd_bg_scpt:MoveBack(guestID) -- фон назад
  elseif 	state == "ReloadRes" then
		obj_wnd_bg_scpt:ReloadRes(viewer.getObjParamI(29014,"ReloadRes",0)) -- перебиваем id при смене материка
  elseif 	state == "InitManual" then
		obj_wnd_bg_scpt:InitManual() -- сбрасываем значения при смене экрана
  else
    obj_wnd_bg_scpt:MoveUp(state,guestID)  -- фон вперёд
	end
end

sadok_libs = class()
sl_buf=1    -- буферное значение
economics_eu=21
economics_as=23460
economics_id=21 -- id активной экономики
eitems_id=23457 -- id группы
gdata_id=27546  -- сюда пишем данные в течении сессии
EconomicsLevel=0
EconomicsEnergy=0
EconomicsRes2=0
EconomicsRes1=0
user_land_play=0
function sadok_libs:init()
  print("sadok_libs:init()")
end
function sadok_libs:shallowcopy(orig) -- делает копию элемента (сохраняя тип), или простой таблицы
  print("sadok_libs:shallowcopy()")
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in pairs(orig) do
            copy[orig_key] = orig_value
        end
    else -- number, string, boolean, etc
        copy = orig
    end
    return copy
end
function sadok_libs:swap_Ar(sl_Ar_name) -- возвращаем копию таблицы sl_Ar_name с рандомным перемешиванием
  print("sadok_libs:swap_Ar()")
    local sl_copy_Ar=sadok_libs:shallowcopy(sl_Ar_name) -- делаем копию, чтобы удалять выбранные елементы
    local sl_swap_Ar={}  -- перемешанная таблица
    sl_swap_Ar[7]=-1     -- чтобы зарезервировать 7-м ячеек
    local sl_rnd=1  -- рандомное число
    for i=1,7 do
      sl_rnd=math.random(1,#sl_copy_Ar)
      sl_swap_Ar[i]=sl_copy_Ar[sl_rnd]
      table.remove(sl_copy_Ar,sl_rnd)
    end
    return sl_swap_Ar
end
function sadok_libs:find_El_Ar_range(sl_Ar_nm,sl_begin,sl_end,sl_Val) -- проверяем наличие значения sl_Val в таблице sl_Ar_nm находящийся в диапазоне [sl_begin,sl_end] 
  print("sadok_libs:find_El_Ar_range()")
  if sl_begin<1 then     -- подпираем выход из диапазона
    sl_begin=1
  end
  if sl_end>#sl_Ar_nm then   -- подпираем выход из диапазона
    sl_end=#sl_Ar_nm
  end
  for i=sl_begin,sl_end do
    if sl_Ar_nm[i]==sl_Val then
      return i
    end
  end
  return nil
end
function sadok_libs:data_Ar(Ar_lists) -- выдаёт одном. массив с ID предметами по ключевому слову Ar_lists 
  print("sadok_libs:data_Ar()")
  local Ar_tools={5169,5170,5171,5172,5173,5174,5175,5176,5177,5178,5179} -- массив с ID charger
  local Ar_amulet={5670,5671,5672,5673}    -- массив с ID amulet
  local Ar_energy={5792,5793,5794,5795}    -- массив с ID energy
  local Ar_hg={6628,6629,6630,6631}        -- массив с ID хинтов хиден сцен
  local Ar_mahjong={6834,6835,6836,6837}   -- массив с ID хинтов mahjong
  local Ar_memory={6838,6839}              -- массив с ID хинтов memory
  local Ar_puzzle={6840,6841,6842}            -- массив с ID хинтов puzzle
  local Ar_tap_the_bubble={11226,11228}       -- массив с ID хинтов tap_the_bubble
  local Ar_words={6844,6843,7206}             -- массив с ID хинтов words
  if Ar_lists=="lottery" then
    return sadok_libs:merge_Ar(Ar_tools,Ar_amulet,Ar_energy,Ar_hg,Ar_mahjong,Ar_memory,Ar_puzzle,Ar_tap_the_bubble,Ar_words)
  elseif Ar_lists=="rnd_1" then
    return sadok_libs:merge_Ar(Ar_tools,Ar_words)
  elseif Ar_lists=="day_sale" then
    local buffer={}
    buffer=sadok_libs:merge_Ar(Ar_tools,Ar_amulet,Ar_energy,Ar_hg,Ar_puzzle)
    if viewer.getOptParamI("tutorial.words",0,1)==1 then
      buffer=sadok_libs:merge_Ar(buffer,Ar_words)
    elseif viewer.getOptParamI("tutorial.memory_rule_0",0,1)==1 then
      buffer=sadok_libs:merge_Ar(buffer,Ar_memory)
    elseif viewer.getOptParamI("tutorial.mahjong",0,1)==1 then
      buffer=sadok_libs:merge_Ar(buffer,Ar_mahjong)
    elseif viewer.getOptParamI("tutorial.tapthebubble",0,1)==1 then
      buffer=sadok_libs:merge_Ar(buffer,Ar_tap_the_bubble)
    end  
    return buffer
  end
  return nil
end
function sadok_libs:random_El_Ar(sl_Ar_nm) -- рандомный элемент из массива
  print("sadok_libs:random_El_Ar()")
  if #sl_Ar_nm>0 then
    local rnd_index= math.random(1,#sl_Ar_nm)
    return sl_Ar_nm[rnd_index]
  else
    return nil
  end
end
function sadok_libs:merge_Ar(...) -- объединяем таблицу в одну
  print("sadok_libs:merge_Ar()")
  local s={}
  local i=1
  for _, n in ipairs({...}) do -- в функции обращаются к ним, как к таблице "arg"
    for j=1,#n do
      s[i]=n[j]
      i=i+1
    end
   end
  return s
end
function sadok_libs:economics_read() -- вычитываем из опций значения из public и заполняем глобальные переменные
  print("sadok_libs:economics_read()")
  EconomicsLevel=viewer.getOptParamI("public.EconomicsLevel",0,1)
  EconomicsEnergy=viewer.getOptParamI("public.EconomicsEnergy",0,1)
  EconomicsRes2=viewer.getOptParamI("public.EconomicsRes2",0,1)
  EconomicsRes1=viewer.getOptParamI("public.EconomicsRes1",0,1)
  user_land_play=viewer.getOptParamS("global_settings.user_land_play","europe",0)
  if user_land_play=="europe" then
    economics_id=economics_eu
  elseif user_land_play=="asia" then
    economics_id=economics_as
  end
end
function sadok_libs:notif_gen() -- генерируем notification ежедневное
  print("sadok_libs:notif_gen()")
  local id_notif=0  -- id уведомления
  local num_ar=math.random() -- список id состоит из двух, в разное время добавлялись
  if num_ar==1 then
    id_notif=math.random(8424,8439)    -- генерируем в диапазоне id
  else
    id_notif=math.random(11431,11441)  -- генерируем в диапазоне id
  end
  viewer.setOptParamI("set_data.daily_notif_id",id_notif,0)
end
function sadok_libs:state(state,guestID)
  sadok_libs:economics_read()
  function get_res_from_txt(number,guestID)
    local id_res=viewer.getResFromTxtDB(viewer.getObjParamI(gdata_id,"get_res_txtID",0),number,0)
    viewer.setObjParamI(guestID,"result_res",id_res) 
  end
  function reward_amulet_cnt() -- награду с учётом амулетов вычитываем из каунтеров
    print ("sadok_libs:state()::reward_amulet_cnt()  ")
    self.res1_id=viewer.getObjParamI(gdata_id,"rew_res1",0)  -- id, счётчик xp 
    self.xp_id=viewer.getObjParamI(gdata_id,"rew_xp",0)  -- id, счётчик res1
    self.res1_id_result=viewer.getObjParamI(gdata_id,"rew_res1_result",0) -- id, текст res1+%
    self.xp_id_result=viewer.getObjParamI(gdata_id,"rew_xp_result",0)  -- id, текст xp+%    
    local val_res1=viewer.getObjParamI(self.res1_id,"val",0)  
    local val_xp=viewer.getObjParamI(self.xp_id,"val",0) 
    reward_amulet_common(val_res1,val_xp)
  end
  function reward_amulet_val() -- награду с учётом амулетов вычитываем значение
    print ("sadok_libs:state()::reward_with_amulet()")
    local val_res1=viewer.getObjParamI(gdata_id,"rew_res1_val",0)  -- id, счётчик xp 
    local val_xp=viewer.getObjParamI(gdata_id,"rew_xp_val",0)  -- id, счётчик res1
    self.res1_id_result=viewer.getObjParamI(gdata_id,"rew_res1_result",0) -- id, текст res1+%
    self.xp_id_result=viewer.getObjParamI(gdata_id,"rew_xp_result",0)  -- id, текст xp+%   
    reward_amulet_common(val_res1,val_xp)
  end
  function reward_amulet_common(val_res1,val_xp) -- награда с учётом амулетов
    if (viewer.getOptParamI("ecomics"..economics_id..".ittimes.itm5672",0,1)>0) then -- itm5672 - амулет богатства  +80%
       viewer.setObjParamS(self.res1_id_result,"txt",val_res1.."+"..math.floor(val_res1*0.8))
    else
       viewer.setObjParamS(self.res1_id_result,"txt",val_res1)
    end 
     if (viewer.getOptParamI("ecomics"..economics_id..".ittimes.itm5670",0,1)>0) then -- itm5670 - амулет опыта  +50%
       viewer.setObjParamS(self.xp_id_result,"txt",val_xp.."+"..math.floor(val_xp*0.5))
    else
        viewer.setObjParamS(self.xp_id_result,"txt",val_xp)
    end 
    viewer.changeObjState(self.res1_id_result,"init")
    viewer.changeObjState(self.xp_id_result,"init")   
  end
  	function progress_loc() -- процент на локации и пишет в опции
    print ("sadok_libs:state()::progress_loc()")
    local num_loc=viewer.getObjParamI(guestID,"param_was",0)  
    local lvl_loc=viewer.getOptParamI("ecomics"..economics_id..".loc"..num_loc..".sl",0,1)
    local score_lvl=viewer.getOptParamI("ecomics"..economics_id..".loc"..num_loc..".sc",0,1)
    local loc_prog=(((100*lvl_loc)+score_lvl)/6)
    viewer.setOptParamF("ecomics"..economics_id..".loc"..num_loc..".loc_prog",loc_prog,1)
  	end
  	print("sadok_libs:state("..state..","..guestID..")")
	if (state == "progress_loc") then
		progress_loc()
  elseif (state == "reward_with_amulet") then
    reward_amulet_cnt()
  elseif (state == "reward_amulet_val") then
    reward_amulet_val()  
  elseif (state == "notif_gen") then
    sadok_libs:notif_gen()
  elseif (state == "get_icon1") then 
    get_res_from_txt(1,guestID)
	end
end

